//rateAdjuster mechanism
//by Vassilis Papapanagiotou and Giannis Zaoudis
//14-04-2009

#include "rateAdjuster.h"
#include <cstdio>

inline double dabs(double a){
	return a>=0?a:-a;
}
//function to check the current loss_rate
void rateAdjuster::adjust(){
	if(currentState == PRE_STATE){
		printf("Eimai sto PRE_STATE!\n");
		region_length = 0.02;
		low_current_region = low_region = input_power - region_length;
		upper_current_region = upper_region = input_power;
		//Allazei etsi ki allios
		currentState = STATE_A;
	        previous_packet_loss = init_packet_loss = input_packet_loss;	
		output_power = input_power;
	}else if (currentState == STATE_A){
		printf("Eimai sto STATE_A! (Expand region)\n");
		low_current_region = low_region = low_region + region_length;
		upper_current_region = upper_region = upper_region + region_length;
		previous_packet_loss = input_packet_loss;
		output_power = upper_region;
		currentState = STATE_B;
	}else if (currentState == STATE_B){
		printf("Eimai sto STATE_B! (test max)\n");
		//Is there improvement ?
		printf("previous_packet_loss = %lf\n",previous_packet_loss);
		double improvement = previous_packet_loss == 0 ? 1.0 : (input_packet_loss - previous_packet_loss)/previous_packet_loss;
		if (improvement < 0.1) {
			currentState = STATE_A;
		}else{
			currentState = STATE_C;
		}

	}else if (currentState == STATE_C){
		//energy consumption optimization
		printf("Eimai sto STATE_C! (check median of current value)\n");
		upper_current_region = (upper_current_region+low_current_region)/2;
		previous_packet_loss = input_packet_loss;
		output_power = upper_current_region;
		currentState = STATE_D;
	}else if (currentState == STATE_D){
		//energy consumption optimization
		printf("Eimai sto STATE_D! (check improvement)\n");
		double improvement = previous_packet_loss == 0 ? 1.0 : (input_packet_loss - previous_packet_loss)/previous_packet_loss;
		if(improvement > -0.1){ //good improvement
			currentState = STATE_C;
		}else{	
			currentState = STATE_E;
		}
	}else if (currentState == STATE_E){
		printf("Eimai sto STATE_E! (backtrack to previous choice)\n");
		if(input_packet_loss > threshold){
			//if not adjust the power by a coefficient of our choice (currently 5%)
//			output += coeff*output;
			//upper bound to prevent excessive consumption 
			if(output_power >= 0.06) output_power = 0.06;
			printf("RATE adjuster: Increase power!\n");
			currentState = STATE_A;
		}else if(input_packet_loss < (0.75*threshold)){
			//we have an area currently 7.5-10% where loss_rate is acceptable
			output_power -= coeff*output_power;
			//lower bound to prevent the base station from halting the transmission
			if(output_power <= 0.02) output_power = 0.02;
			printf("RATE adjuster: MEIONO to power!\n");
		}
		previous_packet_loss = input_packet_loss;
	}
}
//	if(input > threshold){
		//if not adjust the power by a coefficient of our choice (currently 5%)
//		output += coeff*output;
		//upper bound to prevent excessive consumption 
//		if(output >= 0.06) output = 0.06;
//		printf("RATE adjuster: Increase power!\n");
//	}else if(input < (0.75*threshold)){
		//we have an area currently 7.5-10% where loss_rate is acceptable
//		output -= coeff*output;
		//lower bound to prevent the base station from halting the transmission
//		if(output <= 0.02) output = 0.02;
//		printf("RATE adjuster: MEIONO to power!\n");
//	}
